"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import abc
import collections.abc
import google.protobuf.empty_pb2
import grpc
import luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2

class GeometryServiceStub:
    def __init__(self, channel: grpc.Channel) -> None: ...
    ListGeometries: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometriesRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometriesResponse,
    ]
    """Lists the geometries available in a project."""
    ListGeometryEntities: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometryEntitiesRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometryEntitiesResponse,
    ]
    """Lists the entities that currently exist in the specified geometry."""
    GetGeometry: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetGeometryRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetGeometryResponse,
    ]
    """Get details and current features of the specified geometry."""
    ListGeometryFeatures: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometryFeaturesRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometryFeaturesResponse,
    ]
    """Lists the current features in the geometry."""
    ListGeometryFeatureIssues: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometryFeatureIssuesRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometryFeatureIssuesResponse,
    ]
    """List any issues with the current features in the geometry."""
    SubscribeGeometry: grpc.UnaryStreamMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.SubscribeGeometryRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.SubscribeGeometryResponse,
    ]
    """Subscribes the clients to the updates in the geometry state of a give geometry id."""
    ModifyGeometry: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ModifyGeometryRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ModifyGeometryResponse,
    ]
    """Applies a modification to the currently loaded geometry. If the id of the
    modification is found in the state, it overrides the modification and
    replays all the operations.
    """
    CreateGeometry: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CreateGeometryRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CreateGeometryResponse,
    ]
    """Create a new geometry using the URL of a file that already exists in the
    project.
    """
    UpdateGeometry: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.UpdateGeometryRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.UpdateGeometryResponse,
    ]
    CopyGeometry: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CopyGeometryRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CopyGeometryResponse,
    ]
    """Copy an existing geometry"""
    DeleteGeometry: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.DeleteGeometryRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.DeleteGeometryResponse,
    ]
    """Delete an existing geometry"""
    StartCheckGeometry: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CheckGeometryRequest,
        google.protobuf.empty_pb2.Empty,
    ]
    """Starts a check geometry operation."""
    GetCheckGeometry: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CheckGeometryRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetCheckGeometryResponse,
    ]
    """Gets the check geometry operation result and status."""
    CheckGeometry: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CheckGeometryRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CheckGeometryResponse,
    ]
    """Check the geometry and report any issues that may prevent meshing."""
    TesselationUpToModification: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.TessellationUpToModificationRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.TessellationUpToModificationResponse,
    ]
    """Returns the tesselation information up to a given active modification ID."""
    LatestTessellation: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.LatestTessellationRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.LatestTessellationResponse,
    ]
    """Returns the latest tesselation of the last available version of the
    geometry. The same information will be broadcast through the subscription
    RPC.
    """
    KeepAlive: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.KeepAliveRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.KeepAliveResponse,
    ]
    """Keeps the worker alive only if the worker is up and running. Clients can
    use this endpoint to make sure that the worker is not killed while the
    client is not actively using the service.
    """
    Panic: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.PanicRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.PanicResponse,
    ]
    """Crashes the service intentionally. Can only be called by staff users and in
    non-production environments.
    """
    StopWorker: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.StopWorkerRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.StopWorkerResponse,
    ]
    """Tries to stop the worker and the manager of a given geometry. Can only be
    called by staff users.
    """
    GetTags: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetTagsRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetTagsResponse,
    ]
    """Get the tags associated with a geometry version. Used by the frontend
    clients since it contains more data about the associativity of faces and
    bodies.
    """
    ListTags: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListTagsRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListTagsResponse,
    ]
    """List the tags associated with a geometry. Used by SDK clients since it
    contains more carefully crafted datastructures since SDK clients expose
    raw response protos for their usage.
    """
    GetGeometryVersion: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetGeometryVersionRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetGeometryVersionResponse,
    ]
    GetSdkCode: grpc.UnaryUnaryMultiCallable[
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetSdkCodeRequest,
        luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetSdkCodeResponse,
    ]
    """Get the SDK code to generate all the geometry versions of a given geometry."""

class GeometryServiceServicer(metaclass=abc.ABCMeta):
    @abc.abstractmethod
    def ListGeometries(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometriesRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometriesResponse:
        """Lists the geometries available in a project."""
    @abc.abstractmethod
    def ListGeometryEntities(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometryEntitiesRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometryEntitiesResponse:
        """Lists the entities that currently exist in the specified geometry."""
    @abc.abstractmethod
    def GetGeometry(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetGeometryRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetGeometryResponse:
        """Get details and current features of the specified geometry."""
    @abc.abstractmethod
    def ListGeometryFeatures(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometryFeaturesRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometryFeaturesResponse:
        """Lists the current features in the geometry."""
    @abc.abstractmethod
    def ListGeometryFeatureIssues(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometryFeatureIssuesRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListGeometryFeatureIssuesResponse:
        """List any issues with the current features in the geometry."""
    @abc.abstractmethod
    def SubscribeGeometry(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.SubscribeGeometryRequest,
        context: grpc.ServicerContext,
    ) -> collections.abc.Iterator[luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.SubscribeGeometryResponse]:
        """Subscribes the clients to the updates in the geometry state of a give geometry id."""
    @abc.abstractmethod
    def ModifyGeometry(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ModifyGeometryRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ModifyGeometryResponse:
        """Applies a modification to the currently loaded geometry. If the id of the
        modification is found in the state, it overrides the modification and
        replays all the operations.
        """
    @abc.abstractmethod
    def CreateGeometry(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CreateGeometryRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CreateGeometryResponse:
        """Create a new geometry using the URL of a file that already exists in the
        project.
        """
    @abc.abstractmethod
    def UpdateGeometry(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.UpdateGeometryRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.UpdateGeometryResponse: ...
    @abc.abstractmethod
    def CopyGeometry(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CopyGeometryRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CopyGeometryResponse:
        """Copy an existing geometry"""
    @abc.abstractmethod
    def DeleteGeometry(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.DeleteGeometryRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.DeleteGeometryResponse:
        """Delete an existing geometry"""
    @abc.abstractmethod
    def StartCheckGeometry(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CheckGeometryRequest,
        context: grpc.ServicerContext,
    ) -> google.protobuf.empty_pb2.Empty:
        """Starts a check geometry operation."""
    @abc.abstractmethod
    def GetCheckGeometry(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CheckGeometryRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetCheckGeometryResponse:
        """Gets the check geometry operation result and status."""
    @abc.abstractmethod
    def CheckGeometry(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CheckGeometryRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.CheckGeometryResponse:
        """Check the geometry and report any issues that may prevent meshing."""
    @abc.abstractmethod
    def TesselationUpToModification(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.TessellationUpToModificationRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.TessellationUpToModificationResponse:
        """Returns the tesselation information up to a given active modification ID."""
    @abc.abstractmethod
    def LatestTessellation(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.LatestTessellationRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.LatestTessellationResponse:
        """Returns the latest tesselation of the last available version of the
        geometry. The same information will be broadcast through the subscription
        RPC.
        """
    @abc.abstractmethod
    def KeepAlive(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.KeepAliveRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.KeepAliveResponse:
        """Keeps the worker alive only if the worker is up and running. Clients can
        use this endpoint to make sure that the worker is not killed while the
        client is not actively using the service.
        """
    @abc.abstractmethod
    def Panic(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.PanicRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.PanicResponse:
        """Crashes the service intentionally. Can only be called by staff users and in
        non-production environments.
        """
    @abc.abstractmethod
    def StopWorker(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.StopWorkerRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.StopWorkerResponse:
        """Tries to stop the worker and the manager of a given geometry. Can only be
        called by staff users.
        """
    @abc.abstractmethod
    def GetTags(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetTagsRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetTagsResponse:
        """Get the tags associated with a geometry version. Used by the frontend
        clients since it contains more data about the associativity of faces and
        bodies.
        """
    @abc.abstractmethod
    def ListTags(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListTagsRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.ListTagsResponse:
        """List the tags associated with a geometry. Used by SDK clients since it
        contains more carefully crafted datastructures since SDK clients expose
        raw response protos for their usage.
        """
    @abc.abstractmethod
    def GetGeometryVersion(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetGeometryVersionRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetGeometryVersionResponse: ...
    @abc.abstractmethod
    def GetSdkCode(
        self,
        request: luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetSdkCodeRequest,
        context: grpc.ServicerContext,
    ) -> luminarycloud._proto.api.v0.luminarycloud.geometry.geometry_pb2.GetSdkCodeResponse:
        """Get the SDK code to generate all the geometry versions of a given geometry."""

def add_GeometryServiceServicer_to_server(servicer: GeometryServiceServicer, server: grpc.Server) -> None: ...
