"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _PhysicsAiLifecycleState:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _PhysicsAiLifecycleStateEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_PhysicsAiLifecycleState.ValueType], builtins.type):  # noqa: F821
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    LIFECYCLE_STATE_UNSPECIFIED: _PhysicsAiLifecycleState.ValueType  # 0
    """Default value, should not be used in practice."""
    LIFECYCLE_STATE_DEVELOPMENT: _PhysicsAiLifecycleState.ValueType  # 1
    """Not ready for general use."""
    LIFECYCLE_STATE_ACTIVE: _PhysicsAiLifecycleState.ValueType  # 2
    """Available for new training jobs."""
    LIFECYCLE_STATE_DEPRECATED: _PhysicsAiLifecycleState.ValueType  # 3
    """Can still serve inference, but not used for new training."""
    LIFECYCLE_STATE_RETIRED: _PhysicsAiLifecycleState.ValueType  # 4
    """Archived; no training or inference support."""

class PhysicsAiLifecycleState(_PhysicsAiLifecycleState, metaclass=_PhysicsAiLifecycleStateEnumTypeWrapper):
    """Lifecycle state of a Physics AI resource (architecture or model version)."""

LIFECYCLE_STATE_UNSPECIFIED: PhysicsAiLifecycleState.ValueType  # 0
"""Default value, should not be used in practice."""
LIFECYCLE_STATE_DEVELOPMENT: PhysicsAiLifecycleState.ValueType  # 1
"""Not ready for general use."""
LIFECYCLE_STATE_ACTIVE: PhysicsAiLifecycleState.ValueType  # 2
"""Available for new training jobs."""
LIFECYCLE_STATE_DEPRECATED: PhysicsAiLifecycleState.ValueType  # 3
"""Can still serve inference, but not used for new training."""
LIFECYCLE_STATE_RETIRED: PhysicsAiLifecycleState.ValueType  # 4
"""Archived; no training or inference support."""
global___PhysicsAiLifecycleState = PhysicsAiLifecycleState

class PhysicsAiArchitectureVersion(google.protobuf.message.Message):
    """A physics ai architecture version."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    CHANGELOG_FIELD_NUMBER: builtins.int
    LIFECYCLE_STATE_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Unique identifier for the architecture version."""
    name: builtins.str
    """Name of the architecture version."""
    changelog: builtins.str
    """Changelog for this version."""
    lifecycle_state: global___PhysicsAiLifecycleState.ValueType
    """Lifecycle state of the architecture version."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
        name: builtins.str = ...,
        changelog: builtins.str = ...,
        lifecycle_state: global___PhysicsAiLifecycleState.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["changelog", b"changelog", "id", b"id", "lifecycle_state", b"lifecycle_state", "name", b"name"]) -> None: ...

global___PhysicsAiArchitectureVersion = PhysicsAiArchitectureVersion

class PhysicsAiArchitecture(google.protobuf.message.Message):
    """A physics ai architecture."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    VERSIONS_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Unique identifier for the architecture."""
    name: builtins.str
    """Name of the architecture."""
    description: builtins.str
    """Description of the architecture."""
    @property
    def versions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PhysicsAiArchitectureVersion]:
        """All versions of this architecture."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
        name: builtins.str = ...,
        description: builtins.str = ...,
        versions: collections.abc.Iterable[global___PhysicsAiArchitectureVersion] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["description", b"description", "id", b"id", "name", b"name", "versions", b"versions"]) -> None: ...

global___PhysicsAiArchitecture = PhysicsAiArchitecture

class ListArchitecturesRequest(google.protobuf.message.Message):
    """Request message for listing physics ai architectures.
    Empty request since we don't use pagination
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___ListArchitecturesRequest = ListArchitecturesRequest

class ListArchitecturesResponse(google.protobuf.message.Message):
    """Response message for listing physics ai architectures."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ARCHITECTURES_FIELD_NUMBER: builtins.int
    @property
    def architectures(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PhysicsAiArchitecture]:
        """List of physics ai architectures."""
    def __init__(
        self,
        *,
        architectures: collections.abc.Iterable[global___PhysicsAiArchitecture] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["architectures", b"architectures"]) -> None: ...

global___ListArchitecturesResponse = ListArchitecturesResponse

class PhysicsAiModelVersion(google.protobuf.message.Message):
    """A physics ai model version."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    LIFECYCLE_STATE_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Unique identifier for the model version."""
    name: builtins.str
    """Name of the model version."""
    lifecycle_state: global___PhysicsAiLifecycleState.ValueType
    """Lifecycle state of the model version."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
        name: builtins.str = ...,
        lifecycle_state: global___PhysicsAiLifecycleState.ValueType = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["id", b"id", "lifecycle_state", b"lifecycle_state", "name", b"name"]) -> None: ...

global___PhysicsAiModelVersion = PhysicsAiModelVersion

class PhysicsAiModel(google.protobuf.message.Message):
    """A physics ai model."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    DESCRIPTION_FIELD_NUMBER: builtins.int
    VERSIONS_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Unique identifier for the model."""
    name: builtins.str
    """Name of the model."""
    description: builtins.str
    """Description of the model."""
    @property
    def versions(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PhysicsAiModelVersion]:
        """All versions of this model."""
    def __init__(
        self,
        *,
        id: builtins.str = ...,
        name: builtins.str = ...,
        description: builtins.str = ...,
        versions: collections.abc.Iterable[global___PhysicsAiModelVersion] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["description", b"description", "id", b"id", "name", b"name", "versions", b"versions"]) -> None: ...

global___PhysicsAiModel = PhysicsAiModel

class ListPretrainedModelsRequest(google.protobuf.message.Message):
    """Request message for listing physics ai models.
    Empty request since we don't use pagination
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    def __init__(
        self,
    ) -> None: ...

global___ListPretrainedModelsRequest = ListPretrainedModelsRequest

class ListPretrainedModelsResponse(google.protobuf.message.Message):
    """Response message for listing physics ai models."""

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MODELS_FIELD_NUMBER: builtins.int
    @property
    def models(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___PhysicsAiModel]:
        """List of physics ai models."""
    def __init__(
        self,
        *,
        models: collections.abc.Iterable[global___PhysicsAiModel] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["models", b"models"]) -> None: ...

global___ListPretrainedModelsResponse = ListPretrainedModelsResponse
