# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABC, ABCMeta
from dataclasses import dataclass, field
from typing import Any
from uuid import uuid4

from google.protobuf.message import Message as _Message
from luminarycloud.tables import RectilinearTable, _param_name_to_table_type
from luminarycloud.types import Vector3, LcFloat
from luminarycloud.types.adfloat import _to_ad_proto, _from_ad_proto
from luminarycloud._helpers._entity_identifier import _create_entity_identifier
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
from luminarycloud._helpers import CodeRepr
import luminarycloud.params.enum._enum_wrappers as enum

from luminarycloud.params.simulation._lib import ParamGroupWrapper, create_unique_id

from luminarycloud.params.simulation.physics.fluid.boundary_conditions.outlet.outlet_strategy_ import (
    OutletStrategy,
)
from luminarycloud.params.simulation.physics.fluid.boundary_conditions.outlet.outlet_strategy_ import *


@dataclass(kw_only=True)
class OutletTargetCorrectedMassFlowRate(OutletStrategy):
    """Specify a target mass flow rate corrected for given reference temperature and pressure (&#856;m<sub>corr</sub> = &#856;m <sup>&radic; T<sub>0</sub></sup> &frasl; <sub>&radic;T<sub>ref</sub></sub> <sup>P<sub>ref</sub></sup> &frasl; <sub>P<sub>0</sub></sub>)."""

    pressure: LcFloat = 101325.0
    "Static pressure at the boundary relative to the material reference pressure. Also used as initial estimate to establish the target mass flow rate if requested."
    target_mass_flow_rate: LcFloat = 1.0
    "Target mass flow rate (or corrected mass flow rate)."
    reference_pressure: LcFloat = 101325.0
    "Absolute total pressure used to compute the corrected mass flow target."
    reference_temperature: LcFloat = 288.15
    "Total temperature used to compute the corrected mass flow target."
