# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABC, ABCMeta
from dataclasses import dataclass, field
from typing import Any
from uuid import uuid4

from google.protobuf.message import Message as _Message
from luminarycloud.tables import RectilinearTable, _param_name_to_table_type
from luminarycloud.types import Vector3, LcFloat
from luminarycloud.types.adfloat import _to_ad_proto, _from_ad_proto
from luminarycloud._helpers._entity_identifier import _create_entity_identifier
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
from luminarycloud._helpers import CodeRepr
import luminarycloud.params.enum._enum_wrappers as enum

from luminarycloud.params.simulation._lib import ParamGroupWrapper, create_unique_id


@dataclass(kw_only=True)
class TurbulenceBoundaryConditions(CodeRepr):
    """Turbulence boundary conditions."""

    spalart_allmaras: enum.TurbulenceSpecificationSpalartAllmaras = (
        enum.TurbulenceSpecificationSpalartAllmaras.TURBULENT_VISCOSITY_RATIO_SA
    )
    "Condition applied to the Spalart-Allmaras turbulence equation at the boundary."
    komega: enum.TurbulenceSpecificationKomega = (
        enum.TurbulenceSpecificationKomega.BC_TURBULENT_VISCOSITY_RATIO_AND_INTENSITY_KOMEGA
    )
    "Condition applied to the k-ω turbulence variables at the boundary."
    viscosity_ratio: LcFloat = 0.21043825715555026
    "Turbulent-to-laminar viscosity ratio at the boundary."
    viscosity: LcFloat = 3.765582173541416e-06
    "Turbulent viscosity at the boundary."
    intensity: LcFloat = 0.05
    "Turbulence intensity at the boundary."
    sa_variable: LcFloat = 4.166705541552236e-05
    "Uniform boundary condition value for the Spalart-Allmaras turbulence variable."
    sa_variable_column_index: int = 0
    "Index of the column of the profile boundary condition table used for the Sparlart-Allmaras variable."
    tke: LcFloat = 4.166705541552236e-05
    "Uniform boundary condition value for the turbulent kinetic energy variable."
    tke_column_index: int = 0
    "Index of the column of the profile boundary condition table used for the turbulent kinetic energy."
    omega: LcFloat = 4.166705541552236e-05
    "Uniform boundary condition value for the specific dissipation rate variable."
    omega_column_index: int = 0
    "Index of the column of the profile boundary condition table used for the specific dissipation rate."
