# Generated by generate_sdk_wrappers.py. DO NOT EDIT

from abc import ABC, ABCMeta
from dataclasses import dataclass, field
from typing import Any
from uuid import uuid4

from google.protobuf.message import Message as _Message
from luminarycloud.tables import RectilinearTable, _param_name_to_table_type
from luminarycloud.types import Vector3, LcFloat
from luminarycloud.types.adfloat import _to_ad_proto, _from_ad_proto
from luminarycloud._helpers._entity_identifier import _create_entity_identifier
from luminarycloud._proto.client import simulation_pb2 as clientpb
from luminarycloud._proto.client.entity_pb2 import EntityIdentifier
from luminarycloud._helpers import CodeRepr
import luminarycloud.params.enum._enum_wrappers as enum

from luminarycloud.params.simulation._lib import ParamGroupWrapper, create_unique_id

from luminarycloud.params.simulation.physics.fluid.turbulence.spalart_allmaras.spalart_allmaras_constants_ import (
    SpalartAllmarasConstants,
)
from luminarycloud.params.simulation.physics.fluid.turbulence.spalart_allmaras.spalart_allmaras_constants_ import *


@dataclass(kw_only=True)
class CustomSpalartAllmarasConstants(SpalartAllmarasConstants):
    """Enter custom turbulence model constants."""

    c_rot: LcFloat = 2.0
    "C<sub>rot</sub> constant of the Spalart-Allmaras turbulence model, used for the rotation correction."
    c_des: LcFloat = 0.65
    "C<sub>des</sub> constant of the Spalart-Allmaras turbulence model for Detached Eddy Simulation."
    c_b_1: LcFloat = 0.1355
    "C<sub>b1</sub> constant of the Spalart-Allmaras turbulence model."
    sigma: LcFloat = 0.6666666666666666
    "sigma constant of the Spalart-Allmaras turbulence model."
    c_b_2: LcFloat = 0.622
    "C<sub>b2</sub> constant of the Spalart-Allmaras turbulence model."
    kappa: LcFloat = 0.41
    "kappa constant of the Spalart-Allmaras turbulence model."
    c_w_2: LcFloat = 0.3
    "C<sub>w2</sub> constant of the Spalart-Allmaras turbulence model."
    c_w_3: LcFloat = 2.0
    "C<sub>w3</sub> constant of the Spalart-Allmaras turbulence model."
    c_v_1: LcFloat = 7.1
    "C<sub>v1</sub> constant of the Spalart-Allmaras turbulence model."
    c_t_3: LcFloat = 1.2
    "C<sub>t3</sub> constant of the Spalart-Allmaras turbulence model."
    c_t_4: LcFloat = 0.5
    "C<sub>t4</sub> constant of the Spalart-Allmaras turbulence model."
    c_r_1: LcFloat = 0.5
    "C<sub>r1</sub> constant of the Spalart-Allmaras turbulence model, used for roughness."
